﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;

//using bootloaderH.cs;


// https://SISOOG.com
//https://t.me/sisoog

namespace BootLoader
{




    public partial class Frmmain : Form
    {

        const string Msg_ConnectPort = "Ready To Connect Please Open Port";
        const string Msg_Restart = "Ready To Connect Please Restart Chip";
        const string Msg_WaitForProgram = "Ready To Programing";
        const string Msg_ErrorFound = "Error. Please Trye Again";
        const string Msg_Complete = "Programing Successfully Complete ";




        const char Mega8 = 'A';
        const char Mega16 = 'B';
        const char Mega64 = 'C';
        const char Mega128 = 'D';
        const char Mega32 = 'E';
        const char Mega162 = 'F';
        const char Mega169 = 'G';
        const char Mega8515 = 'H';
        const char Mega8535 = 'I';
        const char Mega163 = 'J';
        const char Mega323 = 'K';
        const char Mega48 = 'L';
        const char Mega88 = 'M';
        const char Mega168 = 'N';

        const byte Mega165 = 0x80;
        const byte Mega3250 = 0x81;
        const byte Mega6450 = 0x82;
        const byte Mega3290 = 0x83;
        const byte Mega6490 = 0x84;
        const byte Mega406 = 0x85;
        const byte Mega640 = 0x86;
        const byte Mega1280 = 0x87;
        const byte Mega2560 = 0x88;
        const byte MCAN128 = 0x89;
        const byte Mega164 = 0x8a;
        const byte Mega328 = 0x8b;
        const byte Mega324 = 0x8c;
        const byte Mega325 = 0x8d;
        const byte Mega644 = 0x8e;
        const byte Mega645 = 0x8f;
        const byte Mega1281 = 0x90;
        const byte Mega2561 = 0x91;
        const byte Mega404 = 0x92;
        const byte MUSB1286 = 0x93;
        const byte MUSB1287 = 0x94;
        const byte MUSB162 = 0x95;
        const byte MUSB646 = 0x96;
        const byte MUSB647 = 0x97;
        const byte MUSB82 = 0x98;
        const byte MCAN32 = 0x9a;
        const byte MCAN64 = 0x9b;
        const byte Mega329 = 0x9c;
        const byte Mega649 = 0x9d;
        const byte Mega256 = 0x9e;

        const char Flash1k = 'g';
        const char Flash2k = 'h';
        const char Flash4k = 'i';
        const char Flash8k = 'l';
        const char Flash16k = 'm';
        const char Flash32k = 'n';
        const char Flash64k = 'o';
        const char Flash128k = 'p';
        const char Flash256k = 'q';
        const char Flash40k = 'r';

        const char EEprom64 = '.';
        const char EEprom128 = '/';
        const char EEprom256 = '0';
        const char EEprom512 = '1';
        const char EEprom1024 = '2';
        const char EEprom2048 = '3';
        const char EEprom4096 = '4';

        const char Boot128 = 'a';
        const char Boot256 = 'b';
        const char Boot512 = 'c';
        const char Boot1024 = 'd';
        const char Boot2048 = 'e';
        const char Boot4096 = 'f';

        const char Page32 = 'Q';
        const char Page64 = 'R';
        const char Page128 = 'S';
        const char Page256 = 'T';
        const char Page512 = 'V';



        int WaitForStart;
        int Now_Send_Data = 0;
        uint Counter_flash = 0;
        ulong SizeOffileHex = 0;
        ulong Pack_Counter1 = 0;
        ulong Pack_Counter2 = 0;
        ulong Pack_Counter3 = 0;

        string Str_Recived;


        // Public_ReadFile_Count[0][datasend] = stcmp[0];

        public static byte[,] Public_ReadFile_Count = new byte[1000, 600];
        byte[,] Public_ReadFile_Count_Coding = new byte[1000, 600];
        //byte[,] Public_ReadFile_Count_DeCoding = new byte[1000, 600];
        // byte[] st1 = new byte[500];



        // FileStream fil_public;// = new FileStream("", FileMode.Open, FileAccess.Read, FileShare.Read, 1000000);

        int GetValidByte(byte b1, byte b2)
        {
            int sum = 0;
            if (b1 >= 0x30 && b1 <= 0x39)
            {
                sum = (b1 - 0x30) * 16;

            }
            else
            {
                if (b1 == 'A') sum += 10 * 16;
                if (b1 == 'B') sum += 11 * 16;
                if (b1 == 'C') sum += 12 * 16;
                if (b1 == 'D') sum += 13 * 16;
                if (b1 == 'E') sum += 14 * 16;
                if (b1 == 'F') sum += 15 * 16;
            }

            if (b2 >= 0x30 && b2 <= 0x39)
            {
                sum += (b2 - 0x30);

            }
            else
            {
                if (b2 == 'A') sum += 10;
                if (b2 == 'B') sum += 11;
                if (b2 == 'C') sum += 12;
                if (b2 == 'D') sum += 13;
                if (b2 == 'E') sum += 14;
                if (b2 == 'F') sum += 15;
            }



            return sum;
        }
        //--------------------------------------------------------------------------------------
        void File2Ram(string AdressFile, int type)
        {
            byte[] st1 = new byte[700];
            byte[] stcmp = new byte[10];
            string st2 = "";
            byte CheckSum = 0;
            int j = 0;
            ulong counter = 0;
            int datasend = 0;
            ulong PointerForFile = 0;
            ulong in_Counter = 0;

            if (type == 1)
            {

                if (AdressFile.Length > 0)
                {
                    FileStream fil_public = new FileStream(AdressFile, FileMode.Open, FileAccess.Read, FileShare.Read, 1000000);
                    for (PointerForFile = 0; PointerForFile < (ulong)fil_public.Length; PointerForFile++)
                    {



                        int nBytesRead = fil_public.ReadByte();
                        st2 += ((char)nBytesRead).ToString();

                        if (nBytesRead == 10)
                        {

                            if (st2[0] != ':')
                            {
                                lst_Message.Items.Add("Error : Not Detect");
                            }
                            else
                            {

                                if (GetValidByte((byte)st2[7], (byte)st2[8]) == 0)
                                    for (j = 9; j < (st2.Length - 4); j += 2)
                                    {

                                        int data = GetValidByte((byte)st2[j], (byte)st2[j + 1]);
                                        CheckSum += (byte)data;
                                        stcmp[0] = (byte)data;
                                        Public_ReadFile_Count[(int)in_Counter, datasend + 2] = stcmp[0];
                                        datasend++;

                                        counter++;

                                        if (datasend > 255)
                                        {

                                            stcmp[0] = (byte)(in_Counter / 256);
                                            stcmp[1] = (byte)(in_Counter % 256);
                                            Public_ReadFile_Count[in_Counter, 0] = stcmp[0];
                                            Public_ReadFile_Count[in_Counter, 1] = stcmp[1];

                                            stcmp[0] = (byte)CheckSum;
                                            Public_ReadFile_Count[in_Counter, 256 + 2] = stcmp[0];
                                            //lst_Message.Items.Add("Send Page=" + in_Counter.ToString() + " CheckSum=" + CheckSum.ToString("X2"));
                                            in_Counter++;
                                            datasend = 0;
                                            CheckSum = 0;
                                            Pack_Counter1++;

                                        }
                                    }


                            }

                            st2 = "";
                        }
                    }

                    if (datasend > 0)
                    {

                        while (datasend < 256)
                        {
                            int data = 0XFF;
                            CheckSum += (byte)data;
                            stcmp[0] = (byte)data;
                            Public_ReadFile_Count[(int)in_Counter, datasend + 2] = stcmp[0];
                            datasend++;
                        }

                        stcmp[0] = (byte)(in_Counter / 256);
                        stcmp[1] = (byte)(in_Counter % 256);
                        Public_ReadFile_Count[in_Counter, 0] = stcmp[0];
                        Public_ReadFile_Count[in_Counter, 1] = stcmp[1];
                        stcmp[0] = (byte)CheckSum;
                        Public_ReadFile_Count[in_Counter, 256 + 2] = stcmp[0];
                        Pack_Counter1++;
                    }

                    lst_Message.Items.Add("Count Page Number=" + Pack_Counter1.ToString());
                    FileInfo fi = new FileInfo(AdressFile);
                    lst_Message.Items.Add("File Time= " + fi.LastWriteTime);
                    lst_Message.Items.Add("  ");
                    //  lst_Message.Items.Add("  ");
                    fil_public.Close();
                    lst_Message.SetSelected(lst_Message.Items.Count - 2, true);
                }

            }

            

            if (type == 3)
            {
                if (AdressFile.Length > 0)
                {
                    FileStream fil_public = new FileStream(AdressFile, FileMode.Open, FileAccess.Read, FileShare.Read, 1000000);
                    for (PointerForFile = 0; PointerForFile < (ulong)fil_public.Length; PointerForFile++)
                    {



                        int nBytesRead = fil_public.ReadByte();
                        st2 += ((char)nBytesRead).ToString();

                        if (nBytesRead == 10)
                        {

                            if (st2[0] != ':')
                            {
                                lst_Message.Items.Add("Error : Not Detect");
                            }
                            else
                            {

                                if (st2.Length > 50)
                                    for (j = 5; j < (st2.Length - 4); j += 2)
                                    {

                                        int data = GetValidByte((byte)st2[j], (byte)st2[j + 1]);
                                        CheckSum += (byte)data;
                                        stcmp[0] = (byte)data;
                                        Public_ReadFile_Count_Coding[(int)in_Counter, datasend + 2] = stcmp[0];
                                        datasend++;

                                        counter++;

                                        if (datasend > 256)
                                        {
                                            stcmp[0] = (byte)(in_Counter / 256);
                                            stcmp[1] = (byte)(in_Counter % 256);
                                            Public_ReadFile_Count_Coding[in_Counter, 0] = stcmp[0];
                                            Public_ReadFile_Count_Coding[in_Counter, 1] = stcmp[1];

                                            stcmp[0] = (byte)CheckSum;
                                            Public_ReadFile_Count_Coding[in_Counter, 256 + 2 + 1] = stcmp[0];
                                            // lst_Message.Items.Add("Send Page=" + in_Counter.ToString() + " CheckSum=" + CheckSum.ToString("X2"));
                                            in_Counter++;
                                            datasend = 0;
                                            CheckSum = 0;
                                            Pack_Counter3++;
                                        }
                                    }

                                if (st2.Length < 50)
                                {
                                    Fill_Parameter(st2, 2);
                                }


                            }

                            st2 = "";
                        }
                    }

                    if (datasend > 0)
                    {

                        while (datasend < 256)
                        {
                            int data = 0XFF;
                            CheckSum += (byte)data;
                            stcmp[0] = (byte)data;
                            Public_ReadFile_Count[(int)in_Counter, datasend + 2] = stcmp[0];
                            datasend++;
                        }

                        stcmp[0] = (byte)(in_Counter / 256);
                        stcmp[1] = (byte)(in_Counter % 256);
                        Public_ReadFile_Count[in_Counter, 0] = stcmp[0];
                        Public_ReadFile_Count[in_Counter, 1] = stcmp[1];
                        stcmp[0] = (byte)CheckSum;
                        Public_ReadFile_Count[in_Counter, 256 + 2] = stcmp[0];
                        Pack_Counter3++;
                    }

                    lst_Message.Items.Add("Count Page Number=" + Pack_Counter3.ToString());
                    FileInfo fi = new FileInfo(AdressFile);
                    lst_Message.Items.Add("File Time= " + fi.LastWriteTime);
                    lst_Message.Items.Add("     ");

                    fil_public.Close();
                    lst_Message.SetSelected(lst_Message.Items.Count - 2, true);
                }
            }


        }

        int Send_data_flash_From_Ram(ulong in_Counter)
        {
            //-------------------------------------------------------------------
            ulong Pack_Counter_Timer = 0;
            //---------------------------------
            if (rdi_flashfile.Checked == true)
                Pack_Counter_Timer = Pack_Counter1;
            //---------------------------------
            if (rdi_decodfile.Checked == true)
                Pack_Counter_Timer = Pack_Counter2;
            //---------------------------------
            if (rdi_codfile.Checked == true)
                Pack_Counter_Timer = Pack_Counter3;
            //---------------------------------------------------------------------
            byte[] st1 = new byte[700];

            if (rdi_flashfile.Checked == true)
                for (int i = 0; i < 300; i++) st1[i] = Public_ReadFile_Count[(int)in_Counter, i];

            if (rdi_codfile.Checked == true)
                for (int i = 0; i < 300; i++) st1[i] = Public_ReadFile_Count_Coding[(int)in_Counter, i];




            string Strr1 = " ";
            for (int i = 0; i < 300; i++) Strr1 = Strr1 + st1[i].ToString("X2");
            if (rdi_ViewSendData.Checked == true) lst_Message.Items.Add(Strr1);



            lst_Message.Items.Add("Sending Page======>#" + in_Counter.ToString());// + " CheckSum=" + CheckSum.ToString("X2"));
            lst_Message.SetSelected(lst_Message.Items.Count - 1, true);

            if (serialPort.IsOpen)
            {
                //serialPort.Write(Public_ReadFile_Count[in_Counter],0,259);

                if (rdi_codfile.Checked == true)
                    serialPort.Write(st1, 0, 260);
                else
                    serialPort.Write(st1, 0, 259);

                Prg_Transfer.Value = (int)(((float)in_Counter / (float)Pack_Counter_Timer) * 100 + 1);
                this.Text =Prg_Transfer.Value.ToString()+ "%   Updater";
               
              
            }
            return 1;
        }

        int Send_data_flash_From_Ram_Coding(ulong in_Counter)
        { 
            byte[] st1 = new byte[700];



          

            string Strr1 = " ";
            for (int i = 0; i < 300; i++) Strr1 = Strr1 + st1[i].ToString("X2");
            lst_Message.Items.Add(Strr1);

            lst_Message.Items.Add("Sending Page======>#" + in_Counter.ToString());// + " CheckSum=" + CheckSum.ToString("X2"));
            lst_Message.SetSelected(lst_Message.Items.Count - 1, true);

            if (serialPort.IsOpen)
            {
                //serialPort.Write(Public_ReadFile_Count[in_Counter],0,259);
                serialPort.Write(st1, 0, 259);
                Prg_Transfer.Value = (int)(((float)in_Counter / (float)Pack_Counter1) * 100 + 1);
            }
            return 1;
        }


        void Send_End_Pack()
        {
            byte[] st1 = new byte[700];
            st1[0] = 0xFF;
            st1[1] = 0xFF;

            if (serialPort.IsOpen)
            {
                //serialPort.Write(Public_ReadFile_Count[in_Counter],0,259);
                serialPort.Write(st1, 0, 2);

            }
        }



        void CheckhexeepromFunc(string AdressFile, int TypeFile)
        {
            byte[] st1 = new byte[500];
            string st2 = "";
            int CheckSum = 0;
            int j = 0;
            uint LineRead = 0;
            int CorrectFile = 1;
            if (AdressFile.Length > 0)
            {
                FileStream fil = new FileStream(AdressFile, FileMode.Open);
                ///if(fil)
                {
                    if (TypeFile == 1) lbl_size1.Text = "Size: " + fil.Length.ToString() + " Byte";
                    if (TypeFile == 2) lbl_Size2.Text = "Size: " + fil.Length.ToString() + " Byte";
                    if (TypeFile == 3) lbl_Size3.Text = "Size: " + fil.Length.ToString() + " Byte";





                    // st2 = st1.

                    for (long i = 0; i < fil.Length; i++)
                    {
                        prgb_CheckHex.Value = (int)((float)((float)i / (float)fil.Length) * 100) + 1;
                        int nBytesRead = fil.ReadByte();
                        st2 += ((char)nBytesRead).ToString();
                        if (nBytesRead == 10)
                        {
                            LineRead++;
                            if (st2[0] != ':')
                            {
                                lst_Message.Items.Add("Error : Not Detect");
                            }
                            else
                            {
                                CheckSum = 0;
                                for (j = 1; j < (st2.Length - 4); j += 2)
                                {
                                    CheckSum += GetValidByte((byte)st2[j], (byte)st2[j + 1]);
                                }


                                int Byte_Check = GetValidByte((byte)st2[j], (byte)st2[j + 1]);
                                int Check_Sub = 0;
                                if (TypeFile == 1)
                                {

                                    if (CheckSum > 255)
                                    {
                                        int n1 = (CheckSum - (CheckSum / 256) * 256);
                                        Check_Sub = 256 - n1;
                                        if (Check_Sub == 256) Check_Sub = 0;
                                    }
                                    else
                                    {
                                        Check_Sub = 256 - CheckSum;
                                        if (Check_Sub == 256) Check_Sub = 0;
                                    }
                                }
                                else
                                {
                                    Check_Sub = (byte)CheckSum;
                                }

                                if (Byte_Check != Check_Sub)
                                {
                                    if (TypeFile == 1)
                                    {
                                        lst_Message.Items.Add(st2.ToString() + "=" + Check_Sub.ToString("X2"));
                                        lst_Message.Items.Add("Hex File Incorrect In Line=" + LineRead.ToString());
                                        txt_FlashAdress.Text = "";
                                        //lst_Message.Items.Add("                    ");
                                    }
                                    if (TypeFile == 2)
                                    {
                                        lst_Message.Items.Add(st2.ToString() + "=" + Check_Sub.ToString("X2"));
                                        lst_Message.Items.Add("DeCoding File Incorrect In Line=" + LineRead.ToString());
                                        Txt_EEpromAdress.Text = "";
                                        //  lst_Message.Items.Add("                    ");
                                    }

                                    CorrectFile = 0;
                                    if (TypeFile == 3 && i > 20)
                                    {
                                        lst_Message.Items.Add(st2.ToString() + "=" + Check_Sub.ToString("X2"));
                                        lst_Message.Items.Add("Coding File Incorrect In Line=" + LineRead.ToString());
                                        Txt_EEpromAdress.Text = "";
                                        // lst_Message.Items.Add("                    ");
                                    }
                                    else
                                    {
                                        CorrectFile = 1;


                                    }







                                }
                                if (TypeFile == 1)
                                {
                                    if ((st2.Length - 4) > 25)
                                        SizeOffileHex += 16;
                                }
                                else
                                {
                                    if ((st2.Length - 4) > 25)
                                        SizeOffileHex += 256;
                                }
                            }

                            st2 = "";
                        }
                    }
                    if (TypeFile == 1)
                    {
                        if (CorrectFile == 1)
                        {
                            lst_Message.Items.Add("Hex File Success Decode");
                            lst_Message.Items.Add("Hex File'Size=" + fil.Length.ToString() + " Byte");
                            //  lst_Message.Items.Add("Data In Hex File=" + SizeOffileHex.ToString() + " Byte");
                            // lst_Message.Items.Add("                    ");
                        }
                        else
                        {
                            lst_Message.Items.Add("Hex File Failed Please Insert Correct File");
                            lst_Message.Items.Add("Hex File'Size=" + fil.Length.ToString() + " Byte");
                            // lst_Message.Items.Add("Data In Hex File=" + SizeOffileHex.ToString() + " Byte");
                            //  lst_Message.Items.Add("                    ");
                        }
                    }
                    if (TypeFile == 2)
                    {
                        if (CorrectFile == 1)
                        {
                            lst_Message.Items.Add("Decode File Success Decode");
                            lst_Message.Items.Add("Decode File'Size=" + fil.Length.ToString() + " Byte");
                            //  lst_Message.Items.Add("Data In EEprom File=" + SizeOffileHex.ToString() + " Byte");
                            // lst_Message.Items.Add("                     ");
                        }
                        else
                        {
                            lst_Message.Items.Add("Decode File Failed Please Insert Correct File");
                            lst_Message.Items.Add("Decode File'Size=" + fil.Length.ToString() + " Byte");
                            //  lst_Message.Items.Add("Data In EEprom File=" + SizeOffileHex.ToString() + " Byte");
                            //lst_Message.Items.Add("                     ");
                        }

                    }

                    if (TypeFile == 3)
                    {
                        if (CorrectFile == 1)
                        {
                            lst_Message.Items.Add("Coding Flash File Success Decode");
                            lst_Message.Items.Add("Coding Flash File'Size=" + fil.Length.ToString() + " Byte");
                            //  lst_Message.Items.Add("Data In EEprom File=" + SizeOffileHex.ToString() + " Byte");
                            //lst_Message.Items.Add("                     ");
                        }
                        else
                        {
                            lst_Message.Items.Add("Coding Flash File Failed Please Insert Correct File");
                            lst_Message.Items.Add("Coding Flash File'Size=" + fil.Length.ToString() + " Byte");
                            //  lst_Message.Items.Add("Data In EEprom File=" + SizeOffileHex.ToString() + " Byte");
                            //lst_Message.Items.Add("                     ");
                        }

                    }

                    //MessageBox.Show("File Is Correct", "Success Decode ", MessageBoxButtons.OK);
                    //lst_Message.Items.Add(nBytesRead.ToString());
                }
                fil.Close();
            }
        }

        public Frmmain()
        {
            InitializeComponent();
        }

        private void Btm_Open_Port_Click(object sender, EventArgs e)
        {
            try
            {
                if (serialPort.IsOpen)
                {
                    Btm_Open_Port.Text = "Open Port";
                    serialPort.Close();
                }
                else
                {

                    serialPort.PortName = cmb_Come_Name.Text;
                    serialPort.BaudRate = int.Parse(cmb_Baude_Rate.Text);
                    serialPort.Open();
                    lbl_Satute.Text = Msg_Restart;
                    Btm_Open_Port.Text = "Close Port";
                }
            }
            catch (System.Exception excep)
            {
                MessageBox.Show(excep.Message, "Error", MessageBoxButtons.OK);
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();

            // Display each port name to the console.
            foreach (string port in ports)
            {
                cmb_Come_Name.Items.Add(port);

            }

            cmb_Baude_Rate.Text = "115200";
            lbl_Satute.Text = Msg_ConnectPort;
            WaitForStart = 1;

        }

        void Fill_Parameter(string Str_Recived, int type)
        {
            if (type == 1)
            {
                switch (Str_Recived[1])
                {
                    case Mega8:
                        lbl_Device.Text = "Mega8";
                        break;
                    case Mega16:
                        lbl_Device.Text = "Mega16";
                        break;
                    case Mega64:
                        lbl_Device.Text = "Mega64";
                        break;
                    case Mega128:
                        lbl_Device.Text = "Mega128";
                        break;
                    case Mega32:
                        lbl_Device.Text = "Mega32";
                        break;
                    case Mega162:
                        lbl_Device.Text = "Mega162";
                        break;
                    case Mega169:
                        lbl_Device.Text = "Mega169";
                        break;
                    case Mega8515:
                        lbl_Device.Text = "Mega8515";
                        break;
                    case Mega8535:
                        lbl_Device.Text = "Mega8535";
                        break;
                    case Mega163:
                        lbl_Device.Text = "Mega163";
                        break;
                    case Mega323:
                        lbl_Device.Text = "Mega323";
                        break;
                    case Mega48:
                        lbl_Device.Text = "Mega48";
                        break;
                    case Mega88:
                        lbl_Device.Text = "Mega88";
                        break;
                    case Mega168:
                        lbl_Device.Text = "Mega168";
                        break;
                }

                switch (Str_Recived[0])
                {
                    case Page32:
                        lbl_PageSize.Text = "Page32";
                        break;
                    case Page64:
                        lbl_PageSize.Text = "Page64";
                        break;
                    case Page128:
                        lbl_PageSize.Text = "Page128";
                        break;
                    case Page256:
                        lbl_PageSize.Text = "Page256";
                        break;
                    case Page512:
                        lbl_PageSize.Text = "Page512";
                        break;

                }


                switch (Str_Recived[2])
                {
                    case Flash1k:
                        Lbl_FlashSize.Text = "Flash1k";
                        break;
                    case Flash2k:
                        Lbl_FlashSize.Text = "Flash2k";
                        break;
                    case Flash4k:
                        Lbl_FlashSize.Text = "Flash4k";
                        break;
                    case Flash8k:
                        Lbl_FlashSize.Text = "Flash8k";
                        break;
                    case Flash16k:
                        Lbl_FlashSize.Text = "Flash16k";
                        break;
                    case Flash32k:
                        Lbl_FlashSize.Text = "Flash32k";
                        break;
                    case Flash64k:
                        Lbl_FlashSize.Text = "Flash64k";
                        break;
                    case Flash256k:
                        Lbl_FlashSize.Text = "Flash256k";
                        break;
                    case Flash40k:
                        Lbl_FlashSize.Text = "Flash40k";
                        break;
                    case Flash128k:
                        Lbl_FlashSize.Text = "Flash128k";
                        break;


                }


                switch (Str_Recived[3])
                {
                    case Boot128:
                        Lbl_BootSize.Text = "Boot128";
                        break;
                    case Boot256:
                        Lbl_BootSize.Text = "Boot256";
                        break;
                    case Boot512:
                        Lbl_BootSize.Text = "Boot512";
                        break;
                    case Boot1024:
                        Lbl_BootSize.Text = "Boot1024";
                        break;
                    case Boot2048:
                        Lbl_BootSize.Text = "Boot2048";
                        break;
                    case Boot4096:
                        Lbl_BootSize.Text = "Boot4096";
                        break;
                }

                switch (Str_Recived[4])
                {
                    case EEprom64:
                        Lbl_EEpromSize.Text = "EEprom64";
                        break;
                    case EEprom128:
                        Lbl_EEpromSize.Text = "EEprom128";
                        break;
                    case EEprom256:
                        Lbl_EEpromSize.Text = "EEprom256";
                        break;
                    case EEprom512:
                        Lbl_EEpromSize.Text = "EEprom512";
                        break;
                    case EEprom1024:
                        Lbl_EEpromSize.Text = "EEprom1024";
                        break;
                    case EEprom2048:
                        Lbl_EEpromSize.Text = "EEprom2048";
                        break;
                    case EEprom4096:
                        Lbl_EEpromSize.Text = "EEprom4096";
                        break;
                }
            }

            if (type == 2)
            {
                switch (Str_Recived[3])
                {
                    case Mega8:
                        lbl_Device.Text = "Mega8";
                        break;
                    case Mega16:
                        lbl_Device.Text = "Mega16";
                        break;
                    case Mega64:
                        lbl_Device.Text = "Mega64";
                        break;
                    case Mega128:
                        lbl_Device.Text = "Mega128";
                        break;
                    case Mega32:
                        lbl_Device.Text = "Mega32";
                        break;
                    case Mega162:
                        lbl_Device.Text = "Mega162";
                        break;
                    case Mega169:
                        lbl_Device.Text = "Mega169";
                        break;
                    case Mega8515:
                        lbl_Device.Text = "Mega8515";
                        break;
                    case Mega8535:
                        lbl_Device.Text = "Mega8535";
                        break;
                    case Mega163:
                        lbl_Device.Text = "Mega163";
                        break;
                    case Mega323:
                        lbl_Device.Text = "Mega323";
                        break;
                    case Mega48:
                        lbl_Device.Text = "Mega48";
                        break;
                    case Mega88:
                        lbl_Device.Text = "Mega88";
                        break;
                    case Mega168:
                        lbl_Device.Text = "Mega168";
                        break;
                }




                switch (Str_Recived[4])
                {
                    case Flash1k:
                        Lbl_FlashSize.Text = "Flash1k";
                        break;
                    case Flash2k:
                        Lbl_FlashSize.Text = "Flash2k";
                        break;
                    case Flash4k:
                        Lbl_FlashSize.Text = "Flash4k";
                        break;
                    case Flash8k:
                        Lbl_FlashSize.Text = "Flash8k";
                        break;
                    case Flash16k:
                        Lbl_FlashSize.Text = "Flash16k";
                        break;
                    case Flash32k:
                        Lbl_FlashSize.Text = "Flash32k";
                        break;
                    case Flash64k:
                        Lbl_FlashSize.Text = "Flash64k";
                        break;
                    case Flash256k:
                        Lbl_FlashSize.Text = "Flash256k";
                        break;
                    case Flash40k:
                        Lbl_FlashSize.Text = "Flash40k";
                        break;
                    case Flash128k:
                        Lbl_FlashSize.Text = "Flash128k";
                        break;


                }


                switch (Str_Recived[6])
                {
                    case Boot128:
                        Lbl_BootSize.Text = "Boot128";
                        break;
                    case Boot256:
                        Lbl_BootSize.Text = "Boot256";
                        break;
                    case Boot512:
                        Lbl_BootSize.Text = "Boot512";
                        break;
                    case Boot1024:
                        Lbl_BootSize.Text = "Boot1024";
                        break;
                    case Boot2048:
                        Lbl_BootSize.Text = "Boot2048";
                        break;
                    case Boot4096:
                        Lbl_BootSize.Text = "Boot4096";
                        break;
                }

                switch (Str_Recived[7])
                {
                    case EEprom64:
                        Lbl_EEpromSize.Text = "EEprom64";
                        break;
                    case EEprom128:
                        Lbl_EEpromSize.Text = "EEprom128";
                        break;
                    case EEprom256:
                        Lbl_EEpromSize.Text = "EEprom256";
                        break;
                    case EEprom512:
                        Lbl_EEpromSize.Text = "EEprom512";
                        break;
                    case EEprom1024:
                        Lbl_EEpromSize.Text = "EEprom1024";
                        break;
                    case EEprom2048:
                        Lbl_EEpromSize.Text = "EEprom2048";
                        break;
                    case EEprom4096:
                        Lbl_EEpromSize.Text = "EEprom4096";
                        break;
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {



            ulong Pack_Counter_Timer = 0;


            if (rdi_flashfile.Checked == true)
                Pack_Counter_Timer = Pack_Counter1;

            if (rdi_decodfile.Checked == true)
                Pack_Counter_Timer = Pack_Counter2;

            if (rdi_codfile.Checked == true)
                Pack_Counter_Timer = Pack_Counter3;






            if (serialPort.IsOpen)
            {

                Str_Recived = serialPort.ReadExisting();
                // lst_Message.Items.Add("Str==" + Str_Recived);

                if (Str_Recived.Length != 0 && WaitForStart == 1)
                {
                    //MessageBox.Show(Str_Recived);


                    for (int i = 0; i < Str_Recived.Length; i++)
                        if (Str_Recived[i] == '>')
                        {
                            serialPort.Write("<");

                            serialPort.Write("S");
                            serialPort.Write("I");
                            serialPort.Write("S");
                            serialPort.Write("O");
                            serialPort.Write("O");

                            if (rdi_codfile.Checked == true)
                            {
                                serialPort.Write("C");
                            }
                            else
                            {
                                serialPort.Write("G");
                            }


                            WaitForStart = 0;
                            i = Str_Recived.Length + 10;
                        }
                    Str_Recived = "";
                }




                if (WaitForStart == 0 && Str_Recived.Length >= 5 && Now_Send_Data == 0)
                {
                    lst_Message.Items.Add("Str In =" + Str_Recived);
                    Fill_Parameter(Str_Recived, 1);




                    if (Str_Recived.Length > 5)
                        switch (Str_Recived[5])
                        {
                            case 'A':
                                lbl_explain.Text = "Trucker";
                                lbl_explain2.Text = " www.parsigps.com";
                                break;

                            default:
                                lbl_explain.Text = "No Defined";
                                break;
                        }
                    else
                    {
                        lbl_explain.Text = "No Defined";
                    }


                    Str_Recived = "";
                    Now_Send_Data = 1;
                    Counter_flash = 0;
                    //if (serialPort.IsOpen)
                    //{
                    //    serialPort.Write("!");
                    //}

                    Str_Recived = "";
                    if (Send_data_flash_From_Ram(Counter_flash) == 0) Now_Send_Data = 0;
                    Counter_flash++;
                }


                if (Now_Send_Data == 1 && Str_Recived.Length > 0)
                {

                    if (Str_Recived[0] == '!')
                    {
                        if (Counter_flash >= Pack_Counter_Timer)
                        {
                            lst_Message.Items.Add("Data Transfer Compelet..");
                            Send_End_Pack();
                            Now_Send_Data = 0;
                            Counter_flash = 0;
                            WaitForStart = 1;
                            lst_Message.SetSelected(lst_Message.Items.Count - 1, true);
                            Str_Recived = "";

                            Btm_Open_Port.Text = "Open Port";
                            serialPort.Close();
                            timer2.Enabled = true;
                        }
                        else
                        {
                            Str_Recived = "";
                            if (Send_data_flash_From_Ram(Counter_flash) == 0) Now_Send_Data = 0;
                            Counter_flash++;
                        }


                    }

                    else if (Str_Recived[0] == '@')
                    {
                        Str_Recived = "";
                        Counter_flash--;
                        if (Send_data_flash_From_Ram(Counter_flash) == 0) Now_Send_Data = 0;
                        Counter_flash++;
                    }





                }





            }
        }

        private void btm_OpenFlashFile_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "Hex File|*.hex";
            openFileDialog1.Title = "Select a Flash File";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                txt_FlashAdress.Text = openFileDialog1.FileName;
                CheckhexeepromFunc(txt_FlashAdress.Text, 1);

                if (txt_FlashAdress.Text.Length > 0)
                {
                    Pack_Counter1 = 0;
                    File2Ram(txt_FlashAdress.Text, 1);
                }
            }


        }


        private void btm_OpeneepromFile_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "Eeprom File|*.Iph";
            openFileDialog1.Title = "Select a Coding Flash File File";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                Txt_EEpromAdress.Text = openFileDialog1.FileName;
                CheckhexeepromFunc(Txt_EEpromAdress.Text, 2);

                if (Txt_EEpromAdress.Text.Length > 0)
                {
                    Pack_Counter2 = 0;
                    File2Ram(Txt_EEpromAdress.Text, 2);

                }


            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            //for(ulong i=250;i<255;i++) 
            //Send_data_flash(i);




        }

        private void button3_Click(object sender, EventArgs e)
        {

        }

        private void label10_Click(object sender, EventArgs e)
        {

        }

        private void btm_OpenCodFlash_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "Eeprom File|*.Iph";
            openFileDialog1.Title = "Select a Coding Flash File File";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                txt_CodingFlash.Text = openFileDialog1.FileName;
                CheckhexeepromFunc(txt_CodingFlash.Text, 3);

                if (Txt_EEpromAdress.Text.Length > 0)
                {
                    Pack_Counter3 = 0;
                    File2Ram(txt_CodingFlash.Text, 2);

                }


            }

        }

        private void groupBox7_Enter(object sender, EventArgs e)
        {

        }

        private void button4_Click(object sender, EventArgs e)
        {

        }

        private void btm_OpeneepromFile_Click_1(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "Eeprom File|*.Iph";
            openFileDialog1.Title = "Select a Flash File File";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                Txt_EEpromAdress.Text = openFileDialog1.FileName;
                CheckhexeepromFunc(Txt_EEpromAdress.Text, 2);

                if (Txt_EEpromAdress.Text.Length > 0)
                {
                    Pack_Counter2 = 0;
                    File2Ram(Txt_EEpromAdress.Text, 2);
                    rdi_decodfile.Checked = true;
                    rdi_mode1.Checked = true;
                    rdi_decodeview.Checked = true;
                    lbl_pack2.Text = "Pack_Count:  " + Pack_Counter2.ToString();

                }

            }
        }

        private void btm_OpenFlashFile_Click_1(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "Eeprom File|*.hex";
            openFileDialog1.Title = "Select a Flash File File";

           

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                txt_FlashAdress.Text = openFileDialog1.FileName;
                CheckhexeepromFunc(txt_FlashAdress.Text, 1);

                if (txt_FlashAdress.Text.Length > 0)
                {
                    Pack_Counter1 = 0;
                    File2Ram(txt_FlashAdress.Text, 1);
                    rdi_flashfile.Checked = true;
                    rdi_mode1.Checked = true;
                    // viewdata(1);
                    rdi_flashView.Checked = true;
                    lbl_pack1.Text = "Pack_Count:  " + Pack_Counter1.ToString();


                }


            }
        }

        private void btm_OpenCodFlash_Click_1(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "Eeprom File|*.PPh";
            openFileDialog1.Title = "Select a Coding Flash File File";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                txt_CodingFlash.Text = openFileDialog1.FileName;
                CheckhexeepromFunc(txt_CodingFlash.Text, 3);

                if (txt_CodingFlash.Text.Length > 0)
                {
                    Pack_Counter3 = 0;
                    File2Ram(txt_CodingFlash.Text, 3);
                    rdi_codfile.Checked = true;
                    rdi_mode3.Checked = true;
                    rdi_codeview.Checked = true;
                    lbl_pack3.Text = "Pack_Count:   " + Pack_Counter3.ToString();

                }

            }
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void Btm_Compare_Click(object sender, EventArgs e)
        {
         
        }

        private void rdi_codfile_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click_1(object sender, EventArgs e)
        {

            //C st1 = new Form.;

        }

        private void btm_dataview_Click(object sender, EventArgs e)
        {
            Frmview st1 = new Frmview();
            st1.ShowDialog();
        }

        private void button1_Click_2(object sender, EventArgs e)
        {
            AboutBox1 st1 = new AboutBox1();
            st1.ShowDialog();
        }

        void viewdata(int type)
        {
            if (type == 1)
            {
                lst_dataview.Items.Clear();
                if (Pack_Counter1 == 0)
                {

                    lst_dataview.Items.Add("No Data Exist To View Sorry..");
                    return;
                }

                for (int j = 0; j < (int)Pack_Counter1; j++)
                {
                    byte[] st1 = new byte[700];
                    for (int i = 0; i < 300; i++) st1[i] = Public_ReadFile_Count[(int)j, i];

                    string Strr1 = " ";
                    for (int i = 0; i < 270; i++) Strr1 = Strr1 + st1[i].ToString("X2");
                    //  for (int i = 0; i < 260; i++) Strr1 = Strr1 + st1[i].ToString("X2");

                    lst_dataview.Items.Add(Strr1);

                }

            }
            if (type == 2)
            {
                lst_dataview.Items.Clear();
                if (Pack_Counter2 == 0)
                {

                    lst_dataview.Items.Add("No Data Exist To View Sorry..");
                    return;
                }

                for (int j = 0; j < (int)Pack_Counter2; j++)
                {
                    byte[] st1 = new byte[700];
                    //for (int i = 0; i < 300; i++) st1[i] = Public_ReadFile_Count_DeCoding[(int)j, i];

                    string Strr1 = " ";
                    for (int i = 0; i < 270; i++) Strr1 = Strr1 + st1[i].ToString("X2");
                    lst_dataview.Items.Add(Strr1);

                }

            }

            if (type == 3)
            {
                lst_dataview.Items.Clear();
                if (Pack_Counter3 == 0)
                {

                    lst_dataview.Items.Add("No Data Exist To View Sorry..");
                    return;
                }

                for (int j = 0; j < (int)Pack_Counter3; j++)
                {
                    byte[] st1 = new byte[700];
                    for (int i = 0; i < 300; i++) st1[i] = Public_ReadFile_Count_Coding[(int)j, i];

                    string Strr1 = " ";
                    for (int i = 0; i < 270; i++) Strr1 = Strr1 + st1[i].ToString("X2");
                    lst_dataview.Items.Add(Strr1);

                }

            }



        }
        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (rdi_flashView.Checked == true) viewdata(1);
            if (rdi_decodeview.Checked == true) viewdata(2);
            if (rdi_codeview.Checked == true) viewdata(3);


        }

        private void lst_dataview_SelectedIndexChanged(object sender, EventArgs e)
        {
            lbl_Select.Text = "Select Line: " + (lst_dataview.SelectedIndex + 1).ToString();
            lbl_total_Line.Text = "Total Line: " + (lst_dataview.Items.Count).ToString();
        }

        private void lbl_total_Line_Click(object sender, EventArgs e)
        {

        }

        private void rdi_decodeview_CheckedChanged(object sender, EventArgs e)
        {
            if (rdi_flashView.Checked == true) viewdata(1);
            if (rdi_decodeview.Checked == true) viewdata(2);
            if (rdi_codeview.Checked == true) viewdata(3);
        }

        private void rdi_codefile_CheckedChanged(object sender, EventArgs e)
        {
            if (rdi_flashView.Checked == true) viewdata(1);
            if (rdi_decodeview.Checked == true) viewdata(2);
            if (rdi_codeview.Checked == true) viewdata(3);
        }

        private void Btm_Compare_Click_1(object sender, EventArgs e)
        {
            
        }

        private void lbl_Device_Click(object sender, EventArgs e)
        {

        }

        private void rdi_mode2_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void rdi_flashfile_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            CheckhexeepromFunc(txt_FlashAdress.Text, 1);

            if (txt_FlashAdress.Text.Length > 0)
            {
                Pack_Counter1 = 0;
                File2Ram(txt_FlashAdress.Text, 1);
                rdi_flashfile.Checked = true;
                rdi_mode1.Checked = true;
                // viewdata(1);
                rdi_flashView.Checked = true;
                lbl_pack1.Text = "Pack_Count:  " + Pack_Counter1.ToString();


            }
        }

        private void button4_Click_1(object sender, EventArgs e)
        {
            Txt_EEpromAdress.Text = openFileDialog1.FileName;
            CheckhexeepromFunc(Txt_EEpromAdress.Text, 2);

            if (Txt_EEpromAdress.Text.Length > 0)
            {
                Pack_Counter2 = 0;
                File2Ram(Txt_EEpromAdress.Text, 2);
                rdi_decodfile.Checked = true;
                rdi_mode1.Checked = true;
                rdi_decodeview.Checked = true;
                lbl_pack2.Text = "Pack_Count:  " + Pack_Counter2.ToString();

            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            txt_CodingFlash.Text = openFileDialog1.FileName;
            CheckhexeepromFunc(txt_CodingFlash.Text, 3);

            if (txt_CodingFlash.Text.Length > 0)
            {
                Pack_Counter3 = 0;
                File2Ram(txt_CodingFlash.Text, 3);
                rdi_codfile.Checked = true;
                rdi_mode3.Checked = true;
                rdi_codeview.Checked = true;
                lbl_pack3.Text = "Pack_Count:   " + Pack_Counter3.ToString();

            }
        }

        private void groupBox6_Enter(object sender, EventArgs e)
        {

        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 st1 = new AboutBox1();
            st1.ShowDialog();
        }

        private void clearAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            lst_Message.Items.Clear();
        }

        private void restartToolStripMenuItem_Click(object sender, EventArgs e)
        {
            lst_Message.Items.Add("Restart ...");
            Send_End_Pack();
            Now_Send_Data = 0;
            Counter_flash = 0;
            WaitForStart = 1;
            lst_Message.SetSelected(lst_Message.Items.Count - 1, true);
            Str_Recived = "";

            Btm_Open_Port.Text = "Open Port";
            serialPort.Close();
        }

        private void Btm_Open_Port_Click_1(object sender, EventArgs e)
        {
            try
            {
                if (serialPort.IsOpen)
                {
                    Btm_Open_Port.Text = "Open Port";
                    serialPort.Close();
                }
                else
                {

                    serialPort.PortName = cmb_Come_Name.Text;
                    serialPort.BaudRate = int.Parse(cmb_Baude_Rate.Text);
                    serialPort.Open();
                    lbl_Satute.Text = Msg_Restart;
                    Btm_Open_Port.Text = "Close Port";
                }
            }
            catch (System.Exception excep)
            {
                MessageBox.Show(excep.Message, "Error", MessageBoxButtons.OK);
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            if (serialPort.IsOpen == false && ChkReOpenPort.Checked == true)
            {
                timer2.Enabled = false;


                try
                {
                    if (serialPort.IsOpen)
                    {
                        Btm_Open_Port.Text = "Open Port";
                        serialPort.Close();
                    }
                    else
                    {

                        serialPort.PortName = cmb_Come_Name.Text;
                        serialPort.BaudRate = int.Parse(cmb_Baude_Rate.Text);
                        serialPort.Open();
                        lbl_Satute.Text = Msg_Restart;
                        Btm_Open_Port.Text = "Close Port";
                    }
                }
                catch (System.Exception excep)
                {
                    MessageBox.Show(excep.Message, "Error", MessageBoxButtons.OK);
                }
            }
        }

        private void prgb_CheckHex_Click(object sender, EventArgs e)
        {

        }



    }
}
